connect Administrador/a12345

CREATE OR REPLACE
PACKAGE PR_CONSULTES IS

/* ------------------------------------- Funci de test de dates introduides per l'usuari
*/
FUNCTION check_date (
        date_test varchar2
	)

	RETURN BOOLEAN;

/* --------------------------------------------- Procediments de consulta
*/

/* Donada una ciutat i una data com a parmetres, el llistat de
	tots els comptadors on el consum mensual de la data
	indicada ha superat el 80% del consum mitj de tots els
	comptadors de la ciutat en aquell mateix perode de temps.
	En aquest llistat caldr retornar la informaci bsica segent:
		- Codi de contracte.
		- La potncia mxima contractada.
		- El tant per cent de consum elctric consumit en relaci
			al consum mitj
	Tot aix ordenat de forma ascendent pel tant per cent de
	consum elctric consumit.
*/

PROCEDURE pr_con_ciutat_data_80
	(t_localitat IN COMPTADORS.localitat%TYPE,
	t_data IN VARCHAR2);

/* Llistat de les 10 centraletes de distribuci que distribueixen
	ms energia, cal mostrar les dades segents:
		- Ladrea de la centraleta de distribuci.
		- Energia emesa per la centraleta de distribuci.
		- Mxima energia que permet la centraleta de distribuci.
	Ordenat de forma descendent per la energia emesa en valor absolut.
*/

PROCEDURE pr_con_top10_centraletes;

/* Llistat de les 10 lnies de comunicaci ms carregades en relaci 
	a la seva prpia capacitat mxima, cal mostrar les dades segents:
		- Codi didentificaci
		- Crrega de la lnia, entesa com la potncia que suporta
			la lnia entre la capacitat mxima de la lnia.
		- Energia a la que es pot ampliar la lnia tenint en
			compte les centrals de producci a les que est connectada.
	Ordenat de forma descendent per la crrega de la lnia en valor absolut.
*/

PROCEDURE pr_con_top10_linies;

/* El llistat dels clients que disposen de comptadors amb servei
	en alta disponibilitat tant de centrals de distribuci, com de
	lnies de comunicaci i de centrals de producci. En concret
	cal mostrar les dades segents:
	- El DNI del client.
	- El codi de contracte.
	- El model del comptador.
*/

PROCEDURE pr_con_clients_alta_disp;

/* Donada una central de producci i un interval de temps,
	volem conixer el consum produt pels comptadors que
	depenen daquesta central i lenergia produda per la central
	en aquest mateix perode.
*/

PROCEDURE pr_con_centrals_produccio
	(t_nom IN CENTRALS_PRODUCCIO.nom%TYPE,
	t_data IN VARCHAR2
        );


/* Percentatge de lectures de comptadors efectuades de forma
	presencial i de forma telemtica en un perode de temps.
*/

PROCEDURE pr_con_modalitat_lectures
	(t_data IN VARCHAR2
        );

/* Llistat de comptadors que tinguin un determinat nombre
	danys dantiguitat.
*/

PROCEDURE pr_con_anys_comptadors
	(t_antiguitat IN NUMBER
        );
END;
/
disconnect;