connect Administrador/a12345

CREATE OR REPLACE
PACKAGE PR_ENTRADES IS


/* ---------------------------------------------------------------------- FUNCIONS DE HISTORICS

-----------------------------------------------------------------------------------------------
*/

/*------------------------------------------------ fn_client_x_NC
Aquesta funci cercar del comptador el id client,
i comprobar que existeixi
*/

FUNCTION fn_client_x_NC
	(t_numero_contracte IN LECTURES_COMPTADORS.numero_contracte%TYPE
	)

RETURN BOOLEAN;

/* ----------------------------------------------------- fn_exist_his_comp_mes_any
Aquesta funci cercar en l'histric de lectures si existeix algun acumulat 
per aquest comptador, mes i any.
*/

FUNCTION fn_exist_his_comp_mes_any
	(t_id_comptador IN HISTORIC_LECTURES_COMPTADORS.comptador%TYPE,
	t_mes IN HISTORIC_LECTURES_COMPTADORS.mes%TYPE,
	t_anyhis IN HISTORIC_LECTURES_COMPTADORS.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* ----------------------------------------------------- fn_calcul_con_mitja_anual_comp
Calcula el consum mitja anual del comptador
Accedeix a la taula HISTORIC_LECTURES_COMPTADORS extreu la dada i la retorna
*/

FUNCTION fn_calcul_con_mitja_anual_comp
	(t_numero_contracte IN LECTURES_COMPTADORS.numero_contracte%TYPE
	)
	RETURN NUMBER;

/* ----------------------------------------------------- fn_cerca_id_client_x_comp
Retorna el id_client de la taula COMPTADORS
*/

FUNCTION fn_cerca_id_client_x_comp
	(t_id_comptador IN COMPTADORS.id%TYPE
	)
	RETURN NUMBER;

/* ----------------------------------------------------- fn_calcul_con_mtj_anual_client
Calcula la mitjana del consum anual del client per a tots els comptador d'aquest
*/

FUNCTION fn_calcul_con_mtj_anual_client
	(t_id_client IN CLIENTS.id%TYPE
	)
	RETURN NUMBER;

/* ----------------------------------------------------- fn_exist_his_linia_mes
Aquesta funci cercar en l'histric de linies si existeix algun acumulat 
per aquest linia, mes i any.
*/

FUNCTION fn_exist_his_linia_mes
	(t_id_linia IN HISTORIC_CARREGA_LINIA_MES.linia%TYPE,
	t_mes IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_MES.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* ----------------------------------------------------- fn_exist_his_linia_anual
Aquesta funci cercar en l'histric de linies si existeix algun acumulat 
per aquest linia i any.
*/

FUNCTION fn_exist_his_linia_anual
	(t_id_linia IN HISTORIC_CARREGA_LINIA_ANUAL.linia%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_ANUAL.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* ----------------------------------------------------- fn_calcul_carrega_mitja_anual
Calcula la mitjana de la carrega anual de la linia 
*/

FUNCTION fn_calcul_carrega_mitja_anual
	(t_id_linia IN HISTORIC_CARREGA_LINIA_ANUAL.linia%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_ANUAL.anyhis%TYPE
	)
	RETURN NUMBER;

/* ----------------------------------------------------- fn_exist_his_produccio_mes
Aquesta funci cercar en l'histric de centrals mensual si existeix algun acumulat 
per aquesta central, mes i any.
*/

FUNCTION fn_exist_his_produccio_mes
	(t_id_central IN HISTORIC_PRODUIDA_MES.central%TYPE,
	t_mes IN HISTORIC_PRODUIDA_MES.mes%TYPE,
	t_anyhis IN HISTORIC_PRODUIDA_MES.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* ----------------------------------------------------- fn_exist_his_produccio_anual
Aquesta funci cercar en l'histric de centrals anuals si existeix algun acumulat 
per aquesta central i any.
*/

FUNCTION fn_exist_his_produccio_anual
	(t_id_central IN HISTORIC_PRODUIDA_ANUAL.central%TYPE,
	t_anyhis IN HISTORIC_PRODUIDA_ANUAL.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* ----------------------------------------------------- fn_exist_his_lec_comp_mes_any
Aquesta funci cercar en l'histric de centrals anuals si existeix algun acumulat 
per aquesta central i any.
*/

FUNCTION fn_exist_his_lec_comp_mes_any
	(t_id_comptador IN HISTORIC_LECTURES_COMPTADORS.comptador%TYPE,
	t_mes IN HISTORIC_LECTURES_COMPTADORS.mes%TYPE,
	t_anyhis IN HISTORIC_LECTURES_COMPTADORS.anyhis%TYPE
	)
	RETURN BOOLEAN;

/* -------------------------------------------- Cerca la central per comptador
Entra el id del comptador
Cerca a la relaci centraletes_comptadors el id de la centraleta
Cerca a la taula CENTALETES el id de la linia
Cerca a la taula linies per id_central
Retorna el id_central de la taula linies
*/

FUNCTION fn_cerca_central_x_comptador
	(t_id_comptador IN COMPTADORS.id%TYPE
	)
	RETURN NUMBER;

/* ------------------------------------------ Comprova que la ciutat t comptadors
Retorna TRUE si existeixen comptadors de la ciutat.
Retorna FALSE si no existeixen.
*/

FUNCTION fn_exist_localitat
      (t_localitat IN COMPTADORS.localitat%TYPE)
	RETURN BOOLEAN;


/*------------------------------------------------ fn_companyia_client
Aquesta funci cercar del comptador el id client, 
lleguir del client per id i retornar la companyia
*/

FUNCTION fn_companyia_client
	(t_numero_contracte IN LECTURES_COMPTADORS.numero_contracte%TYPE
	)
	RETURN VARCHAR2;


/* ------------------------------------------------------------------- Crrega de dades diaries

-----------------------------------------------------------------------------------------------

/* --------------------------------------------------- Altualitza taula HISTORIC_LECTURES_COMPTADORS
*/

PROCEDURE pr_actua_his_lec_comptadors
	(t_id_comptador IN HISTORIC_LECTURES_COMPTADORS.comptador%TYPE,
	t_anyhis HISTORIC_LECTURES_COMPTADORS.anyhis%TYPE,
	t_mes IN HISTORIC_LECTURES_COMPTADORS.mes%TYPE,
	t_consum IN HISTORIC_LECTURES_COMPTADORS.consum%TYPE
	);

/* --------------------------------------------------- Altualitza taula COMPTADORS
*/

PROCEDURE pr_actua_comptador
	(t_numero_contracte IN COMPTADORS.numero_contracte%TYPE,
	t_consum IN COMPTADORS.lectura_acumulada%TYPE
	);

/* --------------------------------------------------- Altualitza taula CLIENTS
*/

PROCEDURE pr_actua_client
	(t_id_comptador IN COMPTADORS.id%TYPE,
	t_consum IN COMPTADORS.lectura_acumulada%TYPE
	);

/* ------------------------------------------------------- Actualitza taula LINIA
	Un comptador pot estar connectat mitjanant 
		 diferents centraletes a diferenats lnies
*/

PROCEDURE pr_actua_linia
	(t_id_comptador IN COMPTADORS.id%TYPE,
	t_consum IN COMPTADORS.lectura_acumulada%TYPE
	);
/* ---------------------------------------------- Altualitza histric de carrega de lnies anual
*/


PROCEDURE pr_his_carrega_linia_anual
	(t_id_linia IN HISTORIC_CARREGA_LINIA_ANUAL.linia%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_consum IN LECTURES_COMPTADORS.consum%TYPE
	);

/* ---------------------------------------------- Altualitza histric de carrega de lnies mensual
*/

PROCEDURE pr_his_carrega_linia_mes
	(t_id_comptador IN COMPTADORS.id%TYPE,
	t_mes IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_consum IN COMPTADORS.lectura_acumulada%TYPE
	);

/* ---------------------------------------------- Altualitza histric de produccio de centrals anual
*/

PROCEDURE pr_his_produccio_anual
	(t_id_central IN HISTORIC_PRODUIDA_ANUAL.central%TYPE,
	t_anyhis IN HISTORIC_PRODUIDA_MES.mes%TYPE,
	t_consum IN LECTURES_COMPTADORS.consum%TYPE
	);

/* ---------------------------------------------- Altualitza histric de produccio de centrals mensual
*/

PROCEDURE pr_his_produccio_mes
	(t_id_comptador IN COMPTADORS.id%TYPE,
	t_mes IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_anyhis IN HISTORIC_CARREGA_LINIA_MES.mes%TYPE,
	t_consum IN COMPTADORS.lectura_acumulada%TYPE
	);


/*----------------------------------------------------- Alta de lectures de comptadors
*/

PROCEDURE pr_alta_lectura_comptador
	(t_numero_contracte IN LECTURES_COMPTADORS.numero_contracte%TYPE,
	t_data_lectura IN LECTURES_COMPTADORS.data_lectura%TYPE,
	t_consum IN LECTURES_COMPTADORS.consum%TYPE,
	t_modalitat IN LECTURES_COMPTADORS.modalitat_lectora%TYPE
	);

END;
/

disconnect;
