connect Administrador/a12345

CREATE OR REPLACE 
PACKAGE PR_ESTADISTIQUES IS

/* --------------------------------------------- Procediments d'estadstiques
*/

/* Donada una central de producci, el consum dels comptadors que depenen de la central.
*/

PROCEDURE pr_est_con_comptadors_central
	(t_nom IN CENTRALS_PRODUCCIO.nom%TYPE
        );

/* Donada una lnia de comunicaci i un any concret, el valor
	mitj de lenergia consumida, tenint en compte que aquest
	consum depn dels comptadors que salimenten mitjanant
	aquesta lnia. Si un comptador pot fer servir dues lnies,
	suposeu que les dues lnies computen el consum per
	garantir que les lnies estan ben dimensionades en cas de
	caiguda dalguna delles.
*/

PROCEDURE pr_est_consum_linia_any
	(t_linia IN LINIES.id%TYPE,
        t_any IN HISTORIC_CARREGA_LINIA_ANUAL.anyhis%TYPE
        );

/* Lnia que ha estat ms carregada a nivell denergia consumida.
*/

PROCEDURE pr_est_carrega_linia;


/* Donat un any concret: percentatge de lnies que superen el
	50% denergia consumida.
*/

PROCEDURE pr_est_per_linies_carrega
        (t_any IN HISTORIC_CARREGA_LINIA_ANUAL.anyhis%TYPE
        );

/* Donat un any concret: el nombre de centrals de producci
	que generen menys del 30% de producci.
*/

PROCEDURE pr_est_centrals_menys_30
        (t_any IN HISTORIC_PRODUIDA_ANUAL.anyhis%TYPE
        );

/* Top-10 de comptadors que histricament han tingut ms consum.
*/

PROCEDURE pr_est_top10_comptadors;

/* Consum mig de tots dels clients.
*/

PROCEDURE pr_est_consum_mig_clients;

END;
/
disconnect;


